<?php

namespace Drupal\jsonapi_earlyrendering_workaround\EventSubscriber;

use Drupal\Core\EventSubscriber\EarlyRenderingControllerWrapperSubscriber as OriginalEarlyRenderingControllerWrapperSubscriber;
use Drupal\Core\Render\RenderContext;


class EarlyRenderingControllerWrapperSubscriber extends OriginalEarlyRenderingControllerWrapperSubscriber {

  protected $originalService;

  public function __construct($originalService) {
    $this->originalService = $originalService;
    parent::__construct($this->originalService->argumentResolver, $this->originalService->renderer);
  }


  protected function wrapControllerExecutionInRenderContext($controller, array $arguments) {
    if(get_class($controller[0]) === "Drupal\jsonapi\Controller\EntityResource"){
      return $this->renderer->executeInRenderContext(new RenderContext(), function () use ($controller, $arguments) {
        return call_user_func_array($controller, $arguments);
      });
    }
    return $this->originalService->wrapControllerExecutionInRenderContext($controller, $arguments);
  }
}
